#ifndef DEVICES_H
#define DEVICES_H

class Logical_device
{
public:
  virtual bool has_changed( void ){return false;};
  virtual void log_change( void ){};
  virtual unsigned short axis( int index ){return 0;};
  virtual unsigned short buttons( void ){return 0;};
};

class HID_device
{
public:
  virtual void send_joystick_report( unsigned short x,
				     unsigned short y,
				     unsigned short z,
				     unsigned short rx,
				     unsigned short ry,
				     unsigned short rz,
				     unsigned short btn ){};
  virtual void send_keyboard_report( int count, byte* buttons ){};
};

class Device_translator
{
public :
  virtual void translate( Logical_device& from, HID_device& to ){};
  virtual void update( Logical_device& from, HID_device& to )
  {
    if (from.has_changed())
      {
	translate( from, to );
	from.log_change();
      }
  }

};

#endif
